---
layout: handbook-page-toc
title: "Reliability:Practices Team"
---

## On this page
{:.no_toc .hidden-md .hidden-lg}

- TOC
{:toc .hidden-md .hidden-lg}

## Mission

The Practices team is a subgroup of the [Reliability Team](https://about.gitlab.com/handbook/engineering/infrastructure/team/reliability/).

Our mission is to ensure the reliability, performance, and availability of GitLab.com by partnering with [Stage Groups](https://about.gitlab.com/handbook/product/categories/) to ensure that features and services are designed and implemented with reliability in mind. The team collaborates with Stage groups to build, maintain, and improve services and ensure the services' [SLO](https://about.gitlab.com/handbook/engineering/error-budgets/error-budget-by-stage-group-example.html#sli-slo-sla) is met as per GitLab.com's [availability](/handbook/engineering/infrastructure/performance-indicators/#gitlabcom-availability)
and [performance](/handbook/engineering/infrastructure/performance-indicators/#gitlab-com-performance) goals.

## Team Members

The following people are members of the Reliability:Practices team

<%= direct_team(manager_slug: 'kwanyangu')%>

## Ownership

Currently, Practices team supports Infrastructure Reliability related to the below services;

| Service | Description |
| ------- | ----------- |
| Git, Cluster | Systems:Gitaly|
| Runner, Runner SaaS | Verify:Runner |
| Fulfillment | Fulfillment:Fulfillment Platform |

## Useful Links

| Workflow | [Issue Labels](https://about.gitlab.com/handbook/engineering/infrastructure/team/reliability/issues.html#labels) <br> [Weekly Issue Triage](https://gitlab.com/groups/gitlab-com/gl-infra/-/issues/?sort=created_date&state=opened&label_name%5B%5D=team%3A%3APractices&first_page_size=100) |
| Backlog | [Current Milestone](https://gitlab.com/groups/gitlab-com/gl-infra/-/boards/4696185) <br> [Service Backlog](https://gitlab.com/groups/gitlab-com/gl-infra/-/boards/4696185) |
| Reaching us | [`#g_infra_practices`](https://gitlab.slack.com/archives/C04M6HVAY49) <br> [`#reliability-lounge`](https://gitlab.slack.com/archives/C03QC5KNW5N) <br> `@gitlab-org/reliability/practices`
| Weekly Agenda | [Weekly alternative APAC/EMEA and EMEA/AMER](https://docs.google.com/document/d/1jKcIw0fRkcAN-vXQuvD0OUJpoxchjVOTqMYdGzeW87I/edit#heading=h.6lawfomkdqum) |
| Achievements | [FY24 - Q1](https://gitlab.com/gitlab-com/gl-infra/reliability/-/issues/17301) |

## Scope of Work

Requests not in the scope below should refer to Reliability team's defined [General Workflow](https://about.gitlab.com/handbook/engineering/infrastructure/team/reliability/#how-we-work--general-workflow) for prioritization and assignment.

 * Stage groups' Infrastructure setup and/or migration work.
 * [Feature Change Lock](https://about.gitlab.com/handbook/engineering/#feature-change-locks) (FCL) related work requiring to pair with the Reliability team
 * Reliability improvements driven by [Error budget spend](https://about.gitlab.com/handbook/engineering/error-budgets/#error-budget-improvements) and requiring pairing between stage groups and reliability team
 * Enabling ownership or self-service for stage groups on specific components, e.g empowering a stage group to understand their monitoring or managing access for troubleshooting
 * Support Service related incidents on Incident RCAs, SLI/SLO iteration, Corrective Actions
 * Develop standards, best practices and technical documentation for reliabile services
 * Technical knowledge sharing and documentation through runbooks, design documents etc
 * Work with stage groups to increase service maturity as per the defined [Service Maturity Model](https://about.gitlab.com/handbook/engineering/infrastructure/service-maturity-model/)
 * Examples:
   - [CustomerDot migration from Azure to GCP](https://gitlab.com/groups/gitlab-com/gl-infra/-/epics/626)
   - [Gitaly Cgroups](https://gitlab.com/groups/gitlab-com/gl-infra/-/epics/344)
   - [CI Decomposition](https://gitlab.com/groups/gitlab-org/-/epics/6160)

### Caveats
The Practices team is not there to reduce the stage team's backlog but to collaborate and support reliability efforts and infrastructure best practices.

The above scope of work might imply some overlap with other teams' functions such as;
  - Capacity planning owned by [Scalability team](https://about.gitlab.com/handbook/engineering/infrastructure/team/scalability/)
  - Observability and Monitoring owned by Reliability:Observability
  - Incident Management owned by overall Reliability team. Currently, in cases of overlaps and doubts, follow the [General Workflow](https://about.gitlab.com/handbook/engineering/infrastructure/team/reliability/#how-we-work--general-workflow) or check-in with the respective Reliability, Engineering manager.

## OKRs

We use quarterly [Objectives and Key Results](https://about.gitlab.com/company/okrs/) to plan and measure our Key Performance Indicators (KPIs).

## Performance indicators

We measure the value we contribute by using [performance indicator metrics](https://about.gitlab.com/handbook/engineering/infrastructure/performance-indicators/#key-performance-indicators).

In addition to the Infrastructure Department's KPIs for [availability](/handbook/engineering/infrastructure/performance-indicators/#gitlabcom-availability)
and [performance](/handbook/engineering/infrastructure/performance-indicators/#gitlab-com-performance) of GitLab.com, the Practices team tracks the following;
 - Service's Pager load
 - Improvements of service SLOs
 - Introduction of better SLIs for services to define customer happiness
 - Improve the [Service Maturity level](https://about.gitlab.com/handbook/engineering/infrastructure/service-maturity-model/).

The Practices team does not necessarily own the above KPIs and metrics but rather facilitate and support them to ensure reliable services and components.

## Technical skills
 - The technical skill required for Practices team is as defined in our [Engineering Infrastructure roles](https://about.gitlab.com/job-families/engineering/infrastructure/) for [Site Reliability Engineer](https://about.gitlab.com/job-families/engineering/infrastructure/site-reliability-engineer/)
 - Able to contribute upstream to the respective product/stage group.
 - Strong knowledge of SLI/SLO in general and how they work at GitLab.

## Dashboards and common links
  - Team dashboards

### Project work VS Operations Work

We strive for a 50% split between project work and operations work.
Having more than 50% operations work is an indicator that the service/team is not in a healthy state and is something that needs to be addressed.
More detail on this can be found in <https://sre.google/workbook/part-II-practices/>

### Gitaly Issue Tracker

<% if ENV['PERISCOPE_EMBED_API_KEY'] %>
  <div>
    <embed width="100%" height="100%" style="min-height:300px;" src="<%= signed_periscope_url({ chart: 15996542,dashboard: 1019503 , embed: "v2"}) %>">
  </div>
  <% else %>
    <p>You must set a <code>PERISCOPE_EMBED_API_KEY</code> environment variable to render this chart.</p>
<% end %>

## Resources

### Weekly Sync Agenda Template

```
Date:

Participants:

1. New Items
   1. ...
2. Standing Items
   1. Incidents and Corrective Actions
   2. Observability Adjustments
   3. Long Term Work
   4. Ideas for Improvements
     1. Automation
     2. Self-Service
```

### Suggested Reporting Template for DRIs

 * What happened last week:
   * Provide 1-2 sentences summarizing work completed.  Include relevant links as needed.
 * What's happening this week?
   * Provide 1-2 sentences summarizing work completed.  Include relevant links as needed.
   * Mention counterpart absences if applicable.
 * Things to be aware of
   * If members are pulled in to incidents or other unrelated work.
   * Service problems or work that could impact other services
   * Link discussions regarding the future of the service here.

### Ongoing Stage group engagements

|**Stage Group**|**Reliability:Practices Team Members**|
|--------------|-----------------------------|
<% data.sections.each do |sectionKey, section| %>
  <% data.stages.stages.select{|stageKey,stage| stage.section==sectionKey}.each do |stageKey, stage| %>
    <% if stage.groups %>
      <% stage.groups.each do |groupKey, group| %>
        <% if group.infra_reliability_team_tag %>
          <%= "| [#{stage.display_name}:#{group.name}](/handbook/product/categories/##{group.name.downcase}-group) | #{team_links_from_group(group: group.infra_reliability_team_tag)} |" %>
        <% end %>
      <% end %>
    <% end %>
  <% end %>
<% end %>

## Best practices

### Pairing with Stage Group

It is encouraged to perform pairings between the Practices team members and their assigned Stage Group team. This provides multiple immediate benefits:
 - It allows to easily spread knowledge that can be of immediate benefit.
 - It helps build a stronger relationship.
 - It allows to easily identify and discuss opportunities for improvement in the
  product.

Both the Practices team member and their assigned Stage Group team members are encouraged to reach out to the respective counterpart to ask whether they have room to work on a specific issue together.
Any identified improvements should be documented by creating issues or creating merge requests.

### Stage Group Weekly meetings

Members of the Practices team are encouraged to identify and attend one or more of their Stage Group's Weekly meetings:

- Share early feedback between the teams.
- Identify potential areas of collaboration where both teams can benefit from each other's knowledge.
- Ask and answer questions synchronously and efficiently in a meeting's setting.
- Stay up to date with the challenges, upcoming due dates and deliverables of the Stage Group.

### Issue boards and projects

Issues for Practices team can be found in the following projects:

### Recurring meetings

| Meeting | Purpose |
| :-------- | :---- |
| Biweekly sync (rotate EMEA/APAC/AMER) | Share news and information and provide an opportunity for people on the team to escalate concerns. |
| Retrospective (weekly) | Discuss what went well, not so well and opportunities for improvements. |
| Roadmap (monthly) | Discuss the vision and roadmap check-in |

### Standups

#### Async Daily Standups

The purpose of the daily standup is to allow team members to have visibility into what everyone else is doing,
provide an avenue for asking and offering help.
We use [geekbot](https://geekbot.com/) integrated with Slack.

#### Async Issue Updates

The purpose of daily updates is to inspect progress and adapt upcoming planned work as necessary.
In an all-remote culture, we keep the updates asynchronous and put them directly in the issues.

The async daily update communicates the progress and confidence using an issue comment.
A daily update may be skipped if there was no progress.

#### Epic weekly updates

A weekly async update should be added to epics related to quarter goals and to epics actively being worked on as per the format in [Project Epic template](https://about.gitlab.com/handbook/engineering/infrastructure/team/reliability/projects.html#project-epic-template)
The update should provide an overview of the progress across the work in progress. Consider adding an update if epic is blocked, if there are competing priorities, and even when not in progress.

### Roadmap
 - Team's roadmap goes here

### Demos
 - Demos go here
